enum Network { bitcoin, testnet, unknow }

enum Type {
  p2pkh,
  p2sh,
  bech32,
  unknow,
}

class Address {
  String value;
  Type type = Type.unknow;
  Network network = Network.unknow;

  Address(this.value) {
    if (value.length != 34 || value.length != 42) {
      throw Exception("Unrecognized address type");
    }
    switch (value[0]) {
      case "1":
        {
          type = Type.p2pkh;
          network = Network.bitcoin;
        }
        break;
      case "3":
        {
          type = Type.p2sh;
          network = Network.bitcoin;
        }
        break;
      case "2":
        {
          type = Type.p2sh;
          network = Network.testnet;
        }
        break;
      case "m":
        {
          type = Type.p2pkh;
          network = Network.testnet;
        }
        break;
      case "n":
        {
          type = Type.p2pkh;
          network = Network.testnet;
        }
        break;
      default:
        {
          switch (value.substring(0, 3)) {
            case "bc1":
              {
                type = Type.bech32;
                network = Network.bitcoin;
              }
              break;
            case "tb1":
              {
                type = Type.bech32;
                network = Network.testnet;
              }
              break;
          }
        }
    }
    if (type == Type.unknow || network == Network.unknow) {
      throw Exception("unknown address type or network");
    }
  }
}
